﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using System.Drawing;

namespace ComboEditorButtonSize
{
    class ChangeSizeButtonFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            EditorWithComboDropDownButtonUIElement buttonDrop;
            EditorWithTextUIElement textEl;
            EditorWithComboUIElement element = parent as EditorWithComboUIElement;

            if(parent is EditorWithComboUIElement)
            {
                if (element != null)
                {
                    textEl = (EditorWithTextUIElement)parent.GetDescendant(typeof(EditorWithTextUIElement)) as EditorWithTextUIElement;
                    buttonDrop = (EditorWithComboDropDownButtonUIElement)parent.GetDescendant(typeof(EditorWithComboDropDownButtonUIElement)) as EditorWithComboDropDownButtonUIElement;
                    if (buttonDrop != null && textEl != null)
                    {
                        textEl.Rect = new Rectangle(textEl.Rect.X - 1, textEl.Rect.Y, textEl.Rect.Width - 15, textEl.Rect.Height);
                        buttonDrop.Rect = new Rectangle(buttonDrop.Rect.X - 15, buttonDrop.Rect.Y, buttonDrop.Rect.Width + 15, buttonDrop.Rect.Height);
                    }
                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
